
.include "m128def.inc"

.list                       ;Programm listen
.listmac                    ;Makros listen


.equ clock = 14745600 ;
.equ baud1 = 19200

 .equ UBRR_VAL=(clock/(16*baud1))-1

 



.def BUFFER	=	r25			




.def temp	=	r16
.def temp1  =	r17





.cseg
.org 0x000                ;  Reset- und Interrupt-Vektoren AT-Mega 128
 jmp reset               ;  Reset Handler
  jmp nix;jmp EXT_INT0    ; IRQ0 Handler
  jmp nix;jmp EXT_INT1    ; IRQ1 Handler
  jmp nix;jmp EXT_INT2    ; IRQ2 Handler
  jmp nix;jmp EXT_INT3    ; IRQ3 Handler
  jmp nix;jmp EXT_INT4    ; IRQ4 Handler
  jmp nix;jmp EXT_INT5    ; IRQ5 Handler
  jmp nix;jmp EXT_INT6    ; IRQ6 Handler
  jmp nix;jmp EXT_INT7    ; IRQ7 Handler
  jmp nix;jmp TIM2_COMP   ; Timer2 Compare Handler
  jmp nix;jmp  TIM2_OVF    ; Timer2 Overflow Handler
  jmp nix;jmp TIM1_CAPT   ; Timer1 Capture Handler
  jmp nix;jmp TIM1_COMPA          ; Timer1 CompareA Handler       **********UHR
  jmp nix;jmp TIM1_COMPB  ; Timer1 CompareB Handler
  jmp nix;jmp TIM1_OVF            ; Timer1 Overflow Handler nix;jmp 
  jmp nix;jmp TIM0_COMP   ; Timer0 Compare Handler
  jmp nix;jmp TIM0_OVF            ; Timer0 Overflow Handler
  jmp nix;jmp SPI_STC     ; SPI Transfer Complete Handler **********PWM
  jmp nix;jmp USART0_RXC  ; USART0 RX Complete Handler
  jmp nix;jmp USART0_DRE  ; USART0,UDR Empty Handler
  jmp nix;jmp USART0_TXC  ; USART0 TX Complete Handler
  jmp nix;jmp ADCINT         ; ADC Conversion Complete Handler
  jmp nix;jmp EE_RDY      ; EEPROM Ready Handler
  jmp nix;jmp ANA_COMP    ; Analog Comparator Handler
  jmp nix;jmp TIM1_COMPC  ; Timer1 CompareC Handler
  jmp nix;jmp TIM3_CAPT   ; Timer3 Capture Handler
  jmp nix;jmp TIM3_COMPA  ; Timer3 CompareA Handler
  jmp nix;jmp TIM3_COMPB  ; Timer3 CompareB Handler
  jmp nix;jmp TIM3_COMPC  ; Timer3 CompareC Handler
  jmp nix;jmp TIM3_OVF    ; Timer3 Overflow Handler
  jmp nix;jmp  USART1_RXC  ; USART1 RX Complete Handlernix;
  jmp nix;jmp USART1_DRE  ; USART1,UDR Empty Handler
  jmp nix;jmp USART1_TXC  ; USART1 TX Complete Handler
  jmp nix;jmp TWI         ; Two-wire Serial Interface Interrupt
nix: reti






reset:



ldi temp, LOW(RAMEND)  ;LOW-Byte der obersten RAM-Adresse
out SPL, temp
ldi temp, HIGH(RAMEND) ;HIGH-Byte der obersten RAM-Adresse
out SPH, temp




     ;**************** USART1 ********************
                      ldi temp,$00                  ;TXC1,U2X1,MPCM1
                      sts UCSR1A,temp

                      ldi temp,1<<TXEN1|1<<UCSZ12   ;RXCIE1,TXCIE1,UDRIE1,RXEN1,TXB81
                      sts UCSR1B,temp

                      ldi temp,1<<UCSZ10|1<<UCSZ11  ;UMSEL11,UMSEL10,UPM11,UPM10,USBS1,UCPOL1
                      sts UCSR1C,temp

                  
  ldi temp, high(UBRR_VAL)
  sts UBRR1H, temp
  ldi temp, low(UBRR_VAL)
  sts UBRR1L, temp



;******************************************************************************
;			Hauptschleife
;******************************************************************************

main:


    


    ldi buffer,$55                ; Adresse
    call send_address
    ldi     buffer, 17
    rcall   send_data                      
    ldi     buffer, 00  ;spalte
    rcall   send_data                     
    ldi     buffer, 5   ;zeile
    rcall   send_data                      ; ...
    


;Text auf lcd ausgeben
    ldi     buffer, 'H'
    rcall   send_data                      ; Unterprogramm aufrufen
    ldi     buffer, 'a'
    rcall   send_data                     
    ldi     buffer, 'l'
    rcall   send_data                      ; ...
    ldi     buffer, 'l'
    rcall   send_data
    ldi     buffer, 'o'
    rcall   send_data
    


rjmp main











;----------------------------------------------------------------------------------------
;                     Adresse senden
;                   
;
send_address:         push temp
send_address10:       lds temp,UCSR1A
                      sbrs temp,UDRE1
                      rjmp send_address10        ; UART bereit?

                      lds temp,UCSR1B
                      sbr temp,1<<TXB81
                      sts UCSR1B,temp             ; Bit8 setzen

                      sts UDR1,buffer
                      pop temp
                      ret

;----------------------------------------------------------------------------------------
;                     Datenbyte senden
;                    

;
send_data:            push temp
send_data10:          lds temp,UCSR1A
                      sbrs temp,UDRE1
                      rjmp send_data10           ; UART bereit?

                      lds temp,UCSR1B
                      cbr temp,1<<TXB81
                      sts UCSR1B,temp             ; Bit8 lschen

                      sts UDR1,buffer               
                      pop temp
                      ret
